#This function runs every tick to see if the wither is too high and teleports it down half a block if it is

#This function is called directly in main:tick

#This function makes no calls
	
##############################################################################################

# First this functions schedules itself to run again.
	# By default, once every five minutes
		schedule function downwither:tick 300s
	# If there is a problematic wither, it instead reschedules itself to occur every tick, as long as the wither remains problematic.	
		execute as @e[tag=problematicWither] run schedule clear downwither:tick
		execute as @e[tag=problematicWither] run schedule function downwither:tick 1

# Second, this Function checks if there is a wither which is problematic
	# That is both above y=154 and standing on minecraft:air
			# and It tags any such wither found as problematic.
		execute as @e[type=minecraft:wither, predicate=downwither:above_wither_ceiling] run tag @s add problematicWither

# Third, this function checks if there is any problematic wither which has had its' problem resolved.
		execute as @e[tag=problematicWither, predicate=downwither:significantly_below_wither_ceiling] run tag @s remove problematicWither

# Finally, if there is still a problematic wither, this function 
	# teleport it down a small amount.
			# A wither that is below at @p ~ ~5 ~ will attempt to increase it's y value by .3 blocks per tick.
				# Downporting by      any number  will allow a wither that wants to descend to do so, and at a faster  rate.
				# Downporting by a smaller number will allow a wither that wants to  ascend to do so, but at a reduced rate. 
				# Downporting by a larger  number will force a wither that wants to  ascend to descend instead, 
					# However, I do not currently know of a way to both forces a wither to descend and prevents it from clipping into the floor.
		execute as @e[tag=problematicWither, predicate=downwither:above_wither_ceiling] at @s run teleport @s ~ ~-0.3 ~
